/**
 * This is a sample Servlet filter. The purpose is to demonstrate adding an HTTP Header to the request
 * It should not be used in production
 */
package com.apex.custom;

import java.io.IOException;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Paramanand Mallik
 *
 */
@WebFilter("/ApexSSOFilter")
public class ApexSSOFilter implements javax.servlet.Filter {
	private ServletContext servletContext;

	/**
	 * @param servletContext
	 */
	public ApexSSOFilter() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.Filter#destroy()
	 */
	@Override
	public void destroy() {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.Filter#doFilter(javax.servlet.ServletRequest,
	 * javax.servlet.ServletResponse, javax.servlet.FilterChain)
	 */
	@Override
	public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain chain)
			throws IOException, ServletException {
		// TODO Auto-generated method stub

		/* Cast ServletRequest to get HTTPServlet request */
		HttpServletRequest request = (HttpServletRequest) servletRequest;

		/* Cast ServletRequest to get HTTPServlet request */
		HttpServletResponse response = (HttpServletResponse) servletResponse;

		/*Create an object of AddParamsToHeader and call the addHeader method. This method will add the value to a new HTTP Header*/
		AddParamsToHeader addParams = new AddParamsToHeader(request);
		addParams.addHeader("Auth-User", request.getUserPrincipal().getName()); /*UserPrinciple returns the value of UserId of the end user*/

		chain.doFilter(addParams, response); /*Proceed to the next element in the chain*/

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.Filter#init(javax.servlet.FilterConfig)
	 */
	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		// TODO Auto-generated method stub
		servletContext = filterConfig.getServletContext();
	}

}
